import { LRParser } from "@lezer/lr"
import { styleTags, tags } from "@lezer/highlight"

// This file was generated by lezer-generator. You probably shouldn't edit it.
const inf$1 = 290,
  nan$1 = 291,
  Bool$1 = 1,
  Ignoring$1 = 2,
  On$1 = 3,
  GroupLeft$1 = 4,
  GroupRight$1 = 5,
  Offset$1 = 6,
  Atan2$1 = 7,
  Avg$1 = 8,
  Bottomk$1 = 9,
  Count$1 = 10,
  CountValues$1 = 11,
  Group$1 = 12,
  Max$1 = 13,
  Min$1 = 14,
  Quantile$1 = 15,
  Stddev$1 = 16,
  Stdvar$1 = 17,
  Sum$1 = 18,
  Topk$1 = 19,
  By$1 = 20,
  Without$1 = 21,
  And$1 = 22,
  Or$1 = 23,
  Unless$1 = 24,
  Start$1 = 25,
  End$1 = 26,
  Any$1 = 27,
  BottomkAvg$1 = 28,
  BottomkMax$1 = 29,
  BottomkMedian$1 = 30,
  BottomkLast$1 = 31,
  BottomkMin$1 = 32,
  Distinct$1 = 33,
  Geomean$1 = 34,
  Histogram$1 = 35,
  Limitk$1 = 36,
  Mad$1 = 37,
  Median$1 = 38,
  Mode$1 = 39,
  OutliersMad$1 = 40,
  Outliersk$1 = 41,
  Quantiles$1 = 42,
  Share$1 = 43,
  Sum2$1 = 44,
  TopkAvg$1 = 45,
  TopkMax$1 = 46,
  TopkMedian$1 = 47,
  TopkLast$1 = 48,
  TopkMin$1 = 49,
  Zscore$1 = 50

// Copyright 2021 The Prometheus Authors

const keywordTokens = {
  inf: inf$1,
  nan: nan$1,
  bool: Bool$1,
  ignoring: Ignoring$1,
  on: On$1,
  group_left: GroupLeft$1,
  group_right: GroupRight$1,
  offset: Offset$1,
}

const specializeIdentifier = (value, stack) => {
  return keywordTokens[value.toLowerCase()] || -1
}

const contextualKeywordTokens = {
  avg: Avg$1,
  atan2: Atan2$1,
  bottomk: Bottomk$1,
  count: Count$1,
  count_values: CountValues$1,
  group: Group$1,
  max: Max$1,
  min: Min$1,
  quantile: Quantile$1,
  stddev: Stddev$1,
  stdvar: Stdvar$1,
  sum: Sum$1,
  topk: Topk$1,
  by: By$1,
  without: Without$1,
  and: And$1,
  or: Or$1,
  unless: Unless$1,
  start: Start$1,
  end: End$1,
  // metricsql
  any: Any$1,
  bottomk_avg: BottomkAvg$1,
  bottomk_max: BottomkMax$1,
  bottomk_median: BottomkMedian$1,
  bottomk_last: BottomkLast$1,
  bottomk_min: BottomkMin$1,
  distinct: Distinct$1,
  geomean: Geomean$1,
  histogram: Histogram$1,
  limitk: Limitk$1,
  mad: Mad$1,
  median: Median$1,
  mode: Mode$1,
  outliers_mad: OutliersMad$1,
  outliersk: Outliersk$1,
  quantiles: Quantiles$1,
  share: Share$1,
  sum2: Sum2$1,
  topk_avg: TopkAvg$1,
  topk_max: TopkMax$1,
  topk_median: TopkMedian$1,
  topk_last: TopkLast$1,
  topk_min: TopkMin$1,
  zscore: Zscore$1,
}

const extendIdentifier = (value, stack) => {
  return contextualKeywordTokens[value.toLowerCase()] || -1
}

// Copyright 2022 The Prometheus Authors

const promQLHighLight = styleTags({
  LineComment: tags.comment,
  LabelName: tags.labelName,
  StringLiteral: tags.string,
  NumberLiteral: tags.number,
  Duration: tags.number,
  Identifier: tags.variableName,
  "Abs Absent AbsentOverTime Acos Acosh Alias Asin Asinh Atan Atanh AvgOverTime Ceil Changes Clamp ClampMax ClampMin Cos Cosh CountOverTime DaysInMonth DayOfMonth DayOfWeek DayOfYear Deg Delta Deriv Exp Floor HistogramCount HistogramFraction HistogramQuantile HistogramSum HoltWinters Hour Idelta Increase Irate LabelReplace LabelJoin LastOverTime Ln Log10 Log2 MaxOverTime MinOverTime Minute Month Pi PredictLinear PresentOverTime QuantileOverTime Rad Rate Resets Round Scalar Sgn Sin Sinh Sort SortDesc Sqrt StddevOverTime StdvarOverTime SumOverTime Tan Tanh Time Timestamp Vector Year AggrOverTime AscentOverTime BitmapAnd BitmapOr BitmapXor BucketsLimit ChangesPrometheus CountEqOverTime CountGtOverTime CountLeOverTime CountNeOverTime DecreasesOverTime DefaultRollup DeltaPrometheus DerivFast DescentOverTime DistinctOverTime DropCommonLabels DurationOverTime FirstOverTime GeomeanOverTime HistogramAvg HistogramOverTime HistogramQuantiles HistogramShare HoeffdingBoundLower HoeffdingBoundUpper Ideriv IncreasePrometheus IncreasePure IncreasesOverTime Integrate Interpolate KeepLastValue KeepNextValue LabelCopy LabelDel LabelGraphiteGroup LabelKeep LabelLowercase LabelMap LabelMatch LabelMismatch LabelMove LabelSet LabelTransform LabelUppercase LabelValue Lag Lifetime LimitOffset MadOverTime MedianOverTime ModeOverTime Now PrometheusBuckets QuantilesOverTime Rand RandExponential RandNormal RangeAvg RangeFirst RangeLast RangeLinearRegression RangeMad RangeMax RangeMin RangeNormalize RangeOverTime RangeQuantile RangeStddev RangeStdvar RangeSum RangeTrimOutliers RangeTrimSpikes RangeTrimZscore RangeZscore RateOverSum RemoveResets Rollup RollupCandlestick RollupDelta RollupDeriv RollupIncrease RollupRate RollupScrapeInterval RunningAvg RunningMax RunningMin RunningSum ScrapeInterval ShareEqOverTime ShareGtOverTime ShareLeOverTime SmoothExponential SortByLabel SortByLabelDesc SortByLabelNumeric SortByLabelNumericDesc StaleSamplesOverTime Step Sum2OverTime TfirstOverTime TimestampWithName TimezoneOffset TlastChangeOverTime TlastOverTime TmaxOverTime TminOverTime Union ZscoreOverTime AvgDaily MedianDaily AvgWeekly MedianWeekly MedianWeeklyWithTrends":
    tags.function(tags.variableName),
  "Any Avg Bottomk Count Count_values Group Max Min Quantile Stddev Stdvar Sum Topk Any BottomkAvg BottomkLast BottomkMax BottomkMedian BottomkMin Distinct Geomean Histogram Limitk Mad Median Mode OutliersMad Outliersk Quantiles Share Sum2 TopkAvg TopkLast TopkMax TopkMedian TopkMin Zscore":
    tags.operatorKeyword,
  "By Without Bool On Ignoring GroupLeft GroupRight Offset Start End":
    tags.modifier,
  "And Unless Or": tags.logicOperator,
  "Sub Add Mul Mod Div Atan2 Eql Neq Lte Lss Gte Gtr EqlRegex EqlSingle NeqRegex Pow At":
    tags.operator,
  UnaryOp: tags.arithmeticOperator,
  "( )": tags.paren,
  "[ ]": tags.squareBracket,
  "{ }": tags.brace,
  "⚠": tags.invalid,
})

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Identifier = {
  __proto__: null,
  absent_over_time: 599,
  absent: 601,
  abs: 603,
  acos: 605,
  acosh: 607,
  asin: 609,
  asinh: 611,
  atan: 613,
  atanh: 615,
  avg_over_time: 617,
  ceil: 619,
  changes: 621,
  clamp: 623,
  clamp_max: 625,
  clamp_min: 627,
  cos: 629,
  cosh: 631,
  count_over_time: 633,
  days_in_month: 635,
  day_of_month: 637,
  day_of_week: 639,
  day_of_year: 641,
  deg: 643,
  delta: 645,
  deriv: 647,
  exp: 649,
  floor: 651,
  histogram_count: 653,
  histogram_fraction: 655,
  histogram_quantile: 657,
  histogram_stddev: 659,
  histogram_stdvar: 661,
  histogram_sum: 663,
  holt_winters: 665,
  hour: 667,
  idelta: 669,
  increase: 671,
  irate: 673,
  label_replace: 675,
  label_join: 677,
  last_over_time: 679,
  ln: 681,
  log10: 683,
  log2: 685,
  max_over_time: 687,
  min_over_time: 689,
  minute: 691,
  month: 693,
  pi: 695,
  predict_linear: 697,
  present_over_time: 699,
  quantile_over_time: 701,
  rad: 703,
  rate: 705,
  resets: 707,
  round: 709,
  scalar: 711,
  sgn: 713,
  sin: 715,
  sinh: 717,
  sort: 719,
  sort_desc: 721,
  sqrt: 723,
  stddev_over_time: 725,
  stdvar_over_time: 727,
  sum_over_time: 729,
  tan: 731,
  tanh: 733,
  timestamp: 735,
  time: 737,
  vector: 739,
  year: 741,
  aggr_over_time: 743,
  alias: 745,
  ascent_over_time: 747,
  bitmap_and: 749,
  bitmap_or: 751,
  bitmap_xor: 753,
  buckets_limit: 755,
  changes_prometheus: 757,
  count_eq_over_time: 759,
  count_gt_over_time: 761,
  count_le_over_time: 763,
  count_ne_over_time: 765,
  decreases_over_time: 767,
  default_rollup: 769,
  delta_prometheus: 771,
  deriv_fast: 773,
  descent_over_time: 775,
  distinct_over_time: 777,
  drop_common_labels: 779,
  duration_over_time: 781,
  first_over_time: 783,
  geomean_over_time: 785,
  histogram_avg: 787,
  histogram_over_time: 789,
  histogram_quantiles: 791,
  histogram_share: 793,
  hoeffding_bound_lower: 795,
  hoeffding_bound_upper: 797,
  ideriv: 799,
  increase_prometheus: 801,
  increase_pure: 803,
  increases_over_time: 805,
  integrate: 807,
  interpolate: 809,
  keep_last_value: 811,
  keep_next_value: 813,
  label_copy: 815,
  label_del: 817,
  label_graphite_group: 819,
  label_keep: 821,
  label_lowercase: 823,
  label_map: 825,
  label_match: 827,
  label_mismatch: 829,
  label_move: 831,
  label_set: 833,
  label_transform: 835,
  label_uppercase: 837,
  label_value: 839,
  lag: 841,
  lifetime: 843,
  limit_offset: 845,
  mad_over_time: 847,
  median_over_time: 849,
  mode_over_time: 851,
  now: 853,
  prometheus_buckets: 855,
  quantiles_over_time: 857,
  rand: 859,
  rand_exponential: 861,
  rand_normal: 863,
  range_avg: 865,
  range_first: 867,
  range_last: 869,
  range_linear_regression: 871,
  range_mad: 873,
  range_max: 875,
  range_min: 877,
  range_normalize: 879,
  range_over_time: 881,
  range_quantile: 883,
  range_stddev: 885,
  range_stdvar: 887,
  range_sum: 889,
  range_trim_outliers: 891,
  range_trim_spikes: 893,
  range_trim_zscore: 895,
  range_zscore: 897,
  rate_over_sum: 899,
  remove_resets: 901,
  rollup: 903,
  rollup_candlestick: 905,
  rollup_delta: 907,
  rollup_deriv: 909,
  rollup_increase: 911,
  rollup_rate: 913,
  rollup_scrape_interval: 915,
  running_avg: 917,
  running_max: 919,
  running_min: 921,
  running_sum: 923,
  scrape_interval: 925,
  share_eq_over_time: 927,
  share_gt_over_time: 929,
  share_le_over_time: 931,
  smooth_exponential: 933,
  sort_by_label: 935,
  sort_by_label_desc: 937,
  sort_by_label_numeric: 939,
  sort_by_label_numeric_desc: 941,
  stale_samples_over_time: 943,
  step: 945,
  sum2_over_time: 947,
  tfirst_over_time: 949,
  timestamp_with_name: 951,
  timezone_offset: 953,
  tlast_change_over_time: 955,
  tlast_over_time: 957,
  tmax_over_time: 959,
  tmin_over_time: 961,
  union: 963,
  zscore_over_time: 965,
  avg_daily: 967,
  median_daily: 969,
  avg_weekly: 971,
  median_weekly: 973,
  median_weekly_with_trends: 975,
}
const parser = LRParser.deserialize({
  version: 14,
  states:
    "GYOYQPOOO0hQPOOOOQO'#Dd'#DdO0mQPO'#DcQ0xQQOOOOQO'#Dy'#DyO0sQPO'#DxOOQO'#IS'#ISO2VQPO'#IYOYQPO'#IUOYQPO'#IXOAnQSO'#I[OAvQQO'#IZOOQO'#IZ'#IZOOQO'#In'#InOOQO'#Dz'#DzOOQO'#D|'#D|OOQO'#D}'#D}OOQO'#EO'#EOOOQO'#EP'#EPOOQO'#EQ'#EQOOQO'#ER'#EROOQO'#ES'#ESOOQO'#ET'#ETOOQO'#EU'#EUOOQO'#EV'#EVOOQO'#EW'#EWOOQO'#EX'#EXOOQO'#EY'#EYOOQO'#EZ'#EZOOQO'#E['#E[OOQO'#E]'#E]OOQO'#E^'#E^OOQO'#E_'#E_OOQO'#E`'#E`OOQO'#Ea'#EaOOQO'#Eb'#EbOOQO'#Ec'#EcOOQO'#Ed'#EdOOQO'#Ee'#EeOOQO'#Ef'#EfOOQO'#Eg'#EgOOQO'#Eh'#EhOOQO'#Ei'#EiOOQO'#Ej'#EjOOQO'#Ek'#EkOOQO'#El'#ElOOQO'#Em'#EmOOQO'#En'#EnOOQO'#Eo'#EoOOQO'#Ep'#EpOOQO'#Eq'#EqOOQO'#Er'#ErOOQO'#Es'#EsOOQO'#Et'#EtOOQO'#Eu'#EuOOQO'#Ev'#EvOOQO'#Ew'#EwOOQO'#Ex'#ExOOQO'#Ey'#EyOOQO'#Ez'#EzOOQO'#E{'#E{OOQO'#E|'#E|OOQO'#E}'#E}OOQO'#FO'#FOOOQO'#FP'#FPOOQO'#FQ'#FQOOQO'#FR'#FROOQO'#FS'#FSOOQO'#FT'#FTOOQO'#FU'#FUOOQO'#FV'#FVOOQO'#FW'#FWOOQO'#FX'#FXOOQO'#FY'#FYOOQO'#FZ'#FZOOQO'#F['#F[OOQO'#F]'#F]OOQO'#F^'#F^OOQO'#F_'#F_OOQO'#F`'#F`OOQO'#Fa'#FaOOQO'#Fb'#FbOOQO'#Fc'#FcOOQO'#Fd'#FdOOQO'#Fe'#FeOOQO'#Ff'#FfOOQO'#Fg'#FgOOQO'#Fh'#FhOOQO'#Fi'#FiOOQO'#Fj'#FjOOQO'#Fk'#FkOOQO'#Fl'#FlOOQO'#Fm'#FmOOQO'#Fn'#FnOOQO'#Fo'#FoOOQO'#Fp'#FpOOQO'#Fq'#FqOOQO'#Fr'#FrOOQO'#Fs'#FsOOQO'#Ft'#FtOOQO'#Fu'#FuOOQO'#Fv'#FvOOQO'#Fw'#FwOOQO'#Fx'#FxOOQO'#Fy'#FyOOQO'#Fz'#FzOOQO'#F{'#F{OOQO'#F|'#F|OOQO'#F}'#F}OOQO'#GO'#GOOOQO'#GP'#GPOOQO'#GQ'#GQOOQO'#GR'#GROOQO'#GS'#GSOOQO'#GT'#GTOOQO'#GU'#GUOOQO'#GV'#GVOOQO'#GW'#GWOOQO'#GX'#GXOOQO'#GY'#GYOOQO'#GZ'#GZOOQO'#G['#G[OOQO'#G]'#G]OOQO'#G^'#G^OOQO'#G_'#G_OOQO'#G`'#G`OOQO'#Ga'#GaOOQO'#Gb'#GbOOQO'#Gc'#GcOOQO'#Gd'#GdOOQO'#Ge'#GeOOQO'#Gf'#GfOOQO'#Gg'#GgOOQO'#Gh'#GhOOQO'#Gi'#GiOOQO'#Gj'#GjOOQO'#Gk'#GkOOQO'#Gl'#GlOOQO'#Gm'#GmOOQO'#Gn'#GnOOQO'#Go'#GoOOQO'#Gp'#GpOOQO'#Gq'#GqOOQO'#Gr'#GrOOQO'#Gs'#GsOOQO'#Gt'#GtOOQO'#Gu'#GuOOQO'#Gv'#GvOOQO'#Gw'#GwOOQO'#Gx'#GxOOQO'#Gy'#GyOOQO'#Gz'#GzOOQO'#G{'#G{OOQO'#G|'#G|OOQO'#G}'#G}OOQO'#HO'#HOOOQO'#HP'#HPOOQO'#HQ'#HQOOQO'#HR'#HROOQO'#HS'#HSOOQO'#HT'#HTOOQO'#HU'#HUOOQO'#HV'#HVOOQO'#HW'#HWOOQO'#HX'#HXOOQO'#HY'#HYOOQO'#HZ'#HZOOQO'#H['#H[OOQO'#H]'#H]OOQO'#H^'#H^OOQO'#H_'#H_OOQO'#H`'#H`OOQO'#Ha'#HaOOQO'#Hb'#HbOOQO'#Hc'#HcOOQO'#Hd'#HdOOQO'#He'#HeOOQO'#Hf'#HfOOQO'#Hg'#HgOOQO'#Hh'#HhOOQO'#Hi'#HiOOQO'#Hj'#HjOOQO'#Hk'#HkOOQO'#Hl'#HlOOQO'#Hm'#HmOOQO'#Hn'#HnOOQO'#Ho'#HoOOQO'#Hp'#HpOOQO'#Hq'#HqOOQO'#Hr'#HrOOQO'#Hs'#HsOOQO'#Ht'#HtOOQO'#Hu'#HuOOQO'#Hv'#HvOOQO'#Hw'#HwOOQO'#Hx'#HxOOQO'#Hy'#HyOOQO'#Hz'#HzOOQO'#H{'#H{OOQO'#H|'#H|OOQO'#H}'#H}OOQO'#IO'#IOOOQO'#IP'#IPQOQPOOOCaQPO'#DeOCfQPO'#DhO0sQPO,59}OCmQQO,59}OEZQPO,5:TOEZQPO,5:TOEZQPO,5:TOEZQPO,5:TOEZQPO,5:TO!&rQQO,5>lO!&wQQO,5>oO!'PQPO,5>|OOQO,5:d,5:dOOQO,5>n,5>nO!'hQQO,5>pO!'oQQO,5>sO!)VQPO'#I]OOQO,5>v,5>vO!)eQPO,5>vOOQO,5>u,5>uO!)mQSO'#DfOOQO,5:P,5:POOQO,5:S,5:SO!)uQQO,5:SOOQO1G/i1G/iOOQO'#Dk'#DkOCaQPO'#DlOOQO'#Ir'#IrO!*PQPO'#IrOYQPO1G/oOYQPO1G/oOYQPO1G/oOYQPO1G/oOYQPO1G/oO!9eQSO1G4WOOQO1G4Z1G4ZO!9mQQO1G4ZO!9rQPO'#ISOOQO'#Id'#IdOOQO1G4h1G4hO!9}QPO1G4hOOQO1G4[1G4[OOQO'#I^'#I^O!:SQPO,5>wO!:XQSO1G4bO!:aQPO1G4bOOQO1G4b1G4bOOQO,5:Q,5:QO!:iQPO,5:QOYQPO'#IgO!:qQPO1G/nOOQO1G/n1G/nO!:yQPO,5:WOOQO,5?^,5?^O!KiQQO7+%ZO!KyQQO7+%ZO!M_QQO7+%ZO!MuQQO7+%ZO# ^QQO7+%ZOOQO7+)r7+)rO# wQQO7+)xOOQO7+)u7+)uO#!PQPO7+*SOOQO1G4c1G4cOOQO,5?S,5?SOOQO7+)|7+)|O#!UQSO7+)|OOQO-E<f-E<fO#!^QSO1G/lO#!fQPO1G/lOOQO1G/l1G/lO#!nQQO,5?ROOQO-E<e-E<eOOQO7+%Y7+%YO#!xQPO1G/rOOQO<<Md<<MdO#2WQPO<<MdOOQO<<Mn<<MnOOQO<<Mh<<MhP#2]QSO'#IhOOQO,5?Q,5?QOOQO7+%W7+%WO#2bQSO7+%WOOQO-E<d-E<dOOQO7+%^7+%^OOQOANCOANCOOOQO<<Hr<<HrP#2jQSO'#If",
  stateData:
    "#2o~O'aOS!TOS~OWQOXQOYQOZQO[QO]QO^QO_QO`QOaQObQOcQOkQOlQOmQOnQOoQOpQOqQOrQOsQOtQOuQOvQOwQOxQOyQOzQO{QO|QO}QO!OQO!PQO!QQO!RQO!SQO!o[O&y^O'^VO'_VO'cXO'g_O'h`O'iaO'jbO'kcO'ldO'meO'nfO'ogO'phO'qiO'rjO'skO'tlO'umO'vnO'woO'xpO'yqO'zrO'{sO'|tO'}uO(OvO(PwO(QxO(RyO(SzO(T{O(U|O(V}O(W!OO(X!PO(Y!QO(Z!RO([!SO(]!TO(^!UO(_!VO(`!WO(a!XO(b!YO(c!ZO(d![O(e!]O(f!^O(g!_O(h!`O(i!aO(j!bO(k!cO(l!dO(m!eO(n!fO(o!gO(p!hO(q!iO(r!jO(s!kO(t!lO(u!mO(v!nO(w!oO(x!pO(y!qO(z!rO({!sO(|!tO(}!uO)O!vO)P!wO)Q!xO)R!yO)S!zO)T!{O)U!|O)V!}O)W#OO)X#PO)Y#QO)Z#RO)[#SO)]#TO)^#UO)_#VO)`#WO)a#XO)b#YO)c#ZO)d#[O)e#]O)f#^O)g#_O)h#`O)i#aO)j#bO)k#cO)l#dO)m#eO)n#fO)o#gO)p#hO)q#iO)r#jO)s#kO)t#lO)u#mO)v#nO)w#oO)x#pO)y#qO)z#rO){#sO)|#tO)}#uO*O#vO*P#wO*Q#xO*R#yO*S#zO*T#{O*U#|O*V#}O*W$OO*X$PO*Y$QO*Z$RO*[$SO*]$TO*^$UO*_$VO*`$WO*a$XO*b$YO*c$ZO*d$[O*e$]O*f$^O*g$_O*h$`O*i$aO*j$bO*k$cO*l$dO*m$eO*n$fO*o$gO*p$hO*q$iO*r$jO*s$kO*t$lO*u$mO*v$nO*w$oO*x$pO*y$qO*z$rO*{$sO*|$tO*}$uO+O$vO+P$wO+Q$xO+R$yO+S$zO+T${O+U$|O+V$}O+W%OO+X%PO+Y%QO+Z%RO+[%SO+]%TO+^%UO+_%VO+`%WO+a%XO+b%YO+c%ZO+d%[O+e%]O+f%^O+g%_O+h%`O+i%aO+j%bO+k%cO+nWO+oWO+pVO+rZO~O!o%dO~Od%eOe%eO'c%fO~OU%oOV%iOf%lOg%mOh%lO!^%iO!a%iO!b%iO!c%iO!d%jO!e%jO!f%kO!g%kO!h%kO!i%kO!j%kO!k%kO'V%pO+l%nO~O'^%rO'_%rO+p%rOW&|XX&|XY&|XZ&|X[&|X]&|X^&|X_&|X`&|Xa&|Xb&|Xc&|Xk&|Xl&|Xm&|Xn&|Xo&|Xp&|Xq&|Xr&|Xs&|Xt&|Xu&|Xv&|Xw&|Xx&|Xy&|Xz&|X{&|X|&|X}&|X!O&|X!P&|X!Q&|X!R&|X!S&|X!o&|X&y&|X'^&|X'_&|X'c&|X'g&|X'h&|X'i&|X'j&|X'k&|X'l&|X'm&|X'n&|X'o&|X'p&|X'q&|X'r&|X's&|X't&|X'u&|X'v&|X'w&|X'x&|X'y&|X'z&|X'{&|X'|&|X'}&|X(O&|X(P&|X(Q&|X(R&|X(S&|X(T&|X(U&|X(V&|X(W&|X(X&|X(Y&|X(Z&|X([&|X(]&|X(^&|X(_&|X(`&|X(a&|X(b&|X(c&|X(d&|X(e&|X(f&|X(g&|X(h&|X(i&|X(j&|X(k&|X(l&|X(m&|X(n&|X(o&|X(p&|X(q&|X(r&|X(s&|X(t&|X(u&|X(v&|X(w&|X(x&|X(y&|X(z&|X({&|X(|&|X(}&|X)O&|X)P&|X)Q&|X)R&|X)S&|X)T&|X)U&|X)V&|X)W&|X)X&|X)Y&|X)Z&|X)[&|X)]&|X)^&|X)_&|X)`&|X)a&|X)b&|X)c&|X)d&|X)e&|X)f&|X)g&|X)h&|X)i&|X)j&|X)k&|X)l&|X)m&|X)n&|X)o&|X)p&|X)q&|X)r&|X)s&|X)t&|X)u&|X)v&|X)w&|X)x&|X)y&|X)z&|X){&|X)|&|X)}&|X*O&|X*P&|X*Q&|X*R&|X*S&|X*T&|X*U&|X*V&|X*W&|X*X&|X*Y&|X*Z&|X*[&|X*]&|X*^&|X*_&|X*`&|X*a&|X*b&|X*c&|X*d&|X*e&|X*f&|X*g&|X*h&|X*i&|X*j&|X*k&|X*l&|X*m&|X*n&|X*o&|X*p&|X*q&|X*r&|X*s&|X*t&|X*u&|X*v&|X*w&|X*x&|X*y&|X*z&|X*{&|X*|&|X*}&|X+O&|X+P&|X+Q&|X+R&|X+S&|X+T&|X+U&|X+V&|X+W&|X+X&|X+Y&|X+Z&|X+[&|X+]&|X+^&|X+_&|X+`&|X+a&|X+b&|X+c&|X+d&|X+e&|X+f&|X+g&|X+h&|X+i&|X+j&|X+k&|X+n&|X+o&|X+p&|X+r&|X~O!Z%uO+s%vO~O+rZOU&}XV&}Xf&}Xg&}Xh&}X!^&}X!a&}X!b&}X!c&}X!d&}X!e&}X!f&}X!g&}X!h&}X!i&}X!j&}X!k&}X'V&}X']&}X+l&}X'e&}X'd&}X~O'c%yO~O'e%{O~PYOd%eOe%eOU!VaV!Vaf!Vag!Vah!Va!^!Va!a!Va!b!Va!c!Va!d!Va!e!Va!f!Va!g!Va!h!Va!i!Va!j!Va!k!Va'V!Va']!Va+l!Va'e!Va'd!Va~OP&OOQ&POR&POW'fPX'fPY'fPZ'fP['fP]'fP^'fP_'fP`'fPa'fPb'fPc'fPk'fPl'fPm'fPn'fPo'fPp'fPq'fPr'fPs'fPt'fPu'fPv'fPw'fPx'fPy'fPz'fP{'fP|'fP}'fP!O'fP!P'fP!Q'fP!R'fP!S'fP!o'fP&y'fP'^'fP'_'fP'c'fP'g'fP'h'fP'i'fP'j'fP'k'fP'l'fP'm'fP'n'fP'o'fP'p'fP'q'fP'r'fP's'fP't'fP'u'fP'v'fP'w'fP'x'fP'y'fP'z'fP'{'fP'|'fP'}'fP(O'fP(P'fP(Q'fP(R'fP(S'fP(T'fP(U'fP(V'fP(W'fP(X'fP(Y'fP(Z'fP(['fP(]'fP(^'fP(_'fP(`'fP(a'fP(b'fP(c'fP(d'fP(e'fP(f'fP(g'fP(h'fP(i'fP(j'fP(k'fP(l'fP(m'fP(n'fP(o'fP(p'fP(q'fP(r'fP(s'fP(t'fP(u'fP(v'fP(w'fP(x'fP(y'fP(z'fP({'fP(|'fP(}'fP)O'fP)P'fP)Q'fP)R'fP)S'fP)T'fP)U'fP)V'fP)W'fP)X'fP)Y'fP)Z'fP)['fP)]'fP)^'fP)_'fP)`'fP)a'fP)b'fP)c'fP)d'fP)e'fP)f'fP)g'fP)h'fP)i'fP)j'fP)k'fP)l'fP)m'fP)n'fP)o'fP)p'fP)q'fP)r'fP)s'fP)t'fP)u'fP)v'fP)w'fP)x'fP)y'fP)z'fP){'fP)|'fP)}'fP*O'fP*P'fP*Q'fP*R'fP*S'fP*T'fP*U'fP*V'fP*W'fP*X'fP*Y'fP*Z'fP*['fP*]'fP*^'fP*_'fP*`'fP*a'fP*b'fP*c'fP*d'fP*e'fP*f'fP*g'fP*h'fP*i'fP*j'fP*k'fP*l'fP*m'fP*n'fP*o'fP*p'fP*q'fP*r'fP*s'fP*t'fP*u'fP*v'fP*w'fP*x'fP*y'fP*z'fP*{'fP*|'fP*}'fP+O'fP+P'fP+Q'fP+R'fP+S'fP+T'fP+U'fP+V'fP+W'fP+X'fP+Y'fP+Z'fP+['fP+]'fP+^'fP+_'fP+`'fP+a'fP+b'fP+c'fP+d'fP+e'fP+f'fP+g'fP+h'fP+i'fP+j'fP+k'fP+n'fP+o'fP+p'fP+r'fP~O&u&XO~O!e&ZO&u&YO~Oi&]Oj&]O'^VO'_VO+n&[O+o&[O+pVO~O'e&`O~P0xO!^%iOU&{aV&{af&{ag&{ah&{a!a&{a!b&{a!c&{a!d&{a!e&{a!f&{a!g&{a!h&{a!i&{a!j&{a!k&{a'V&{a']&{a+l&{a'e&{a'd&{a~O!k&aO'R&aO'S&aO'T&aO~O'd&cO+s&eO~O!Z&gO'e&fO~O'd&hO'e&jO~P0xOQ&POR&POW'fXX'fXY'fXZ'fX['fX]'fX^'fX_'fX`'fXa'fXb'fXc'fXk'fXl'fXm'fXn'fXo'fXp'fXq'fXr'fXs'fXt'fXu'fXv'fXw'fXx'fXy'fXz'fX{'fX|'fX}'fX!O'fX!P'fX!Q'fX!R'fX!S'fX!o'fX&y'fX'^'fX'_'fX'c'fX'g'fX'h'fX'i'fX'j'fX'k'fX'l'fX'm'fX'n'fX'o'fX'p'fX'q'fX'r'fX's'fX't'fX'u'fX'v'fX'w'fX'x'fX'y'fX'z'fX'{'fX'|'fX'}'fX(O'fX(P'fX(Q'fX(R'fX(S'fX(T'fX(U'fX(V'fX(W'fX(X'fX(Y'fX(Z'fX(['fX(]'fX(^'fX(_'fX(`'fX(a'fX(b'fX(c'fX(d'fX(e'fX(f'fX(g'fX(h'fX(i'fX(j'fX(k'fX(l'fX(m'fX(n'fX(o'fX(p'fX(q'fX(r'fX(s'fX(t'fX(u'fX(v'fX(w'fX(x'fX(y'fX(z'fX({'fX(|'fX(}'fX)O'fX)P'fX)Q'fX)R'fX)S'fX)T'fX)U'fX)V'fX)W'fX)X'fX)Y'fX)Z'fX)['fX)]'fX)^'fX)_'fX)`'fX)a'fX)b'fX)c'fX)d'fX)e'fX)f'fX)g'fX)h'fX)i'fX)j'fX)k'fX)l'fX)m'fX)n'fX)o'fX)p'fX)q'fX)r'fX)s'fX)t'fX)u'fX)v'fX)w'fX)x'fX)y'fX)z'fX){'fX)|'fX)}'fX*O'fX*P'fX*Q'fX*R'fX*S'fX*T'fX*U'fX*V'fX*W'fX*X'fX*Y'fX*Z'fX*['fX*]'fX*^'fX*_'fX*`'fX*a'fX*b'fX*c'fX*d'fX*e'fX*f'fX*g'fX*h'fX*i'fX*j'fX*k'fX*l'fX*m'fX*n'fX*o'fX*p'fX*q'fX*r'fX*s'fX*t'fX*u'fX*v'fX*w'fX*x'fX*y'fX*z'fX*{'fX*|'fX*}'fX+O'fX+P'fX+Q'fX+R'fX+S'fX+T'fX+U'fX+V'fX+W'fX+X'fX+Y'fX+Z'fX+['fX+]'fX+^'fX+_'fX+`'fX+a'fX+b'fX+c'fX+d'fX+e'fX+f'fX+g'fX+h'fX+i'fX+j'fX+k'fX+n'fX+o'fX+p'fX+r'fX~O+m&rO+q&sO~O&u&tO~O'^%rO'_%rO+p%rO~O'c&uO~O&y&vO~O!Z%uO+s&xO~O'd&yO+s&xO~O'd&{O'e&}O~O'd&hO'e'QO~OS'ROT'ROW!`aX!`aY!`aZ!`a[!`a]!`a^!`a_!`a`!`aa!`ab!`ac!`ak!`al!`am!`an!`ao!`ap!`aq!`ar!`as!`at!`au!`av!`aw!`ax!`ay!`az!`a{!`a|!`a}!`a!O!`a!P!`a!Q!`a!R!`a!S!`a!o!`a&y!`a'^!`a'_!`a'c!`a'g!`a'h!`a'i!`a'j!`a'k!`a'l!`a'm!`a'n!`a'o!`a'p!`a'q!`a'r!`a's!`a't!`a'u!`a'v!`a'w!`a'x!`a'y!`a'z!`a'{!`a'|!`a'}!`a(O!`a(P!`a(Q!`a(R!`a(S!`a(T!`a(U!`a(V!`a(W!`a(X!`a(Y!`a(Z!`a([!`a(]!`a(^!`a(_!`a(`!`a(a!`a(b!`a(c!`a(d!`a(e!`a(f!`a(g!`a(h!`a(i!`a(j!`a(k!`a(l!`a(m!`a(n!`a(o!`a(p!`a(q!`a(r!`a(s!`a(t!`a(u!`a(v!`a(w!`a(x!`a(y!`a(z!`a({!`a(|!`a(}!`a)O!`a)P!`a)Q!`a)R!`a)S!`a)T!`a)U!`a)V!`a)W!`a)X!`a)Y!`a)Z!`a)[!`a)]!`a)^!`a)_!`a)`!`a)a!`a)b!`a)c!`a)d!`a)e!`a)f!`a)g!`a)h!`a)i!`a)j!`a)k!`a)l!`a)m!`a)n!`a)o!`a)p!`a)q!`a)r!`a)s!`a)t!`a)u!`a)v!`a)w!`a)x!`a)y!`a)z!`a){!`a)|!`a)}!`a*O!`a*P!`a*Q!`a*R!`a*S!`a*T!`a*U!`a*V!`a*W!`a*X!`a*Y!`a*Z!`a*[!`a*]!`a*^!`a*_!`a*`!`a*a!`a*b!`a*c!`a*d!`a*e!`a*f!`a*g!`a*h!`a*i!`a*j!`a*k!`a*l!`a*m!`a*n!`a*o!`a*p!`a*q!`a*r!`a*s!`a*t!`a*u!`a*v!`a*w!`a*x!`a*y!`a*z!`a*{!`a*|!`a*}!`a+O!`a+P!`a+Q!`a+R!`a+S!`a+T!`a+U!`a+V!`a+W!`a+X!`a+Y!`a+Z!`a+[!`a+]!`a+^!`a+_!`a+`!`a+a!`a+b!`a+c!`a+d!`a+e!`a+f!`a+g!`a+h!`a+i!`a+j!`a+k!`a+n!`a+o!`a+p!`a+r!`a~O!^%iOU!]qf!]qg!]qh!]q!d!]q!e!]q!f!]q!g!]q!h!]q!i!]q!j!]q!k!]q'V!]q']!]q+l!]q'e!]q'd!]q~OV!]q!a!]q!b!]q!c!]q~P!J_OV%iO!a%iO!b%iO!c%iO~P!J_OV%iO!^%iO!a%iO!b%iO!c%iO!d%jO!e%jOU!]qf!]qg!]qh!]q'V!]q']!]q+l!]q'e!]q'd!]q~O!f!]q!g!]q!h!]q!i!]q!j!]q!k!]q~P!LZO!f%kO!g%kO!h%kO!i%kO!j%kO!k%kO~P!LZOV%iOf%lOh%lO!^%iO!a%iO!b%iO!c%iO!d%jO!e%jO!f%kO!g%kO!h%kO!i%kO!j%kO!k%kO~OU!]qg!]q'V!]q']!]q+l!]q'e!]q'd!]q~P!N]O&u'TO+m'SO~O'e'UO~O!Z%uO+s'VO~O!Z'XO'e'YO~O'd'ZO'e'YO~O'd'Za'e'Za~P0xO'c%yOW!`iX!`iY!`iZ!`i[!`i]!`i^!`i_!`i`!`ia!`ib!`ic!`ik!`il!`im!`in!`io!`ip!`iq!`ir!`is!`it!`iu!`iv!`iw!`ix!`iy!`iz!`i{!`i|!`i}!`i!O!`i!P!`i!Q!`i!R!`i!S!`i!o!`i&y!`i'^!`i'_!`i'g!`i'h!`i'i!`i'j!`i'k!`i'l!`i'm!`i'n!`i'o!`i'p!`i'q!`i'r!`i's!`i't!`i'u!`i'v!`i'w!`i'x!`i'y!`i'z!`i'{!`i'|!`i'}!`i(O!`i(P!`i(Q!`i(R!`i(S!`i(T!`i(U!`i(V!`i(W!`i(X!`i(Y!`i(Z!`i([!`i(]!`i(^!`i(_!`i(`!`i(a!`i(b!`i(c!`i(d!`i(e!`i(f!`i(g!`i(h!`i(i!`i(j!`i(k!`i(l!`i(m!`i(n!`i(o!`i(p!`i(q!`i(r!`i(s!`i(t!`i(u!`i(v!`i(w!`i(x!`i(y!`i(z!`i({!`i(|!`i(}!`i)O!`i)P!`i)Q!`i)R!`i)S!`i)T!`i)U!`i)V!`i)W!`i)X!`i)Y!`i)Z!`i)[!`i)]!`i)^!`i)_!`i)`!`i)a!`i)b!`i)c!`i)d!`i)e!`i)f!`i)g!`i)h!`i)i!`i)j!`i)k!`i)l!`i)m!`i)n!`i)o!`i)p!`i)q!`i)r!`i)s!`i)t!`i)u!`i)v!`i)w!`i)x!`i)y!`i)z!`i){!`i)|!`i)}!`i*O!`i*P!`i*Q!`i*R!`i*S!`i*T!`i*U!`i*V!`i*W!`i*X!`i*Y!`i*Z!`i*[!`i*]!`i*^!`i*_!`i*`!`i*a!`i*b!`i*c!`i*d!`i*e!`i*f!`i*g!`i*h!`i*i!`i*j!`i*k!`i*l!`i*m!`i*n!`i*o!`i*p!`i*q!`i*r!`i*s!`i*t!`i*u!`i*v!`i*w!`i*x!`i*y!`i*z!`i*{!`i*|!`i*}!`i+O!`i+P!`i+Q!`i+R!`i+S!`i+T!`i+U!`i+V!`i+W!`i+X!`i+Y!`i+Z!`i+[!`i+]!`i+^!`i+_!`i+`!`i+a!`i+b!`i+c!`i+d!`i+e!`i+f!`i+g!`i+h!`i+i!`i+j!`i+k!`i+n!`i+o!`i+p!`i+r!`i~O+m'^O~O!Z%uO~O!Z'XO'e'_O~O!Z'XO~O",
  goto: ",Q'gPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'h't(Q(WP(a'hP(j(qPPPPPPPPPPP'h({)XP)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X)X'hP)e'h'hP'h'h)t'h*Q*a*iPPP'hP*lP*o*u*{PPPPP+RPPP+qe^OXY%f&S&T&U&V&W&heROXY%f&S&T&U&V&W&hQ%gRR%}%hQ%z%eQ&k&PR']'RQ%hRQ%qUR%}%gZ&R%i%j%k%l%mY&Q%i%j%k%l%mR&l&ReUOXY%f&S&T&U&V&W&heTOXY%f&S&T&U&V&W&hd^OXY%f&S&T&U&V&W&hR&^%peYOXY%f&S&T&U&V&W&hd]OXY%f&S&T&U&V&W&hR%x[Q%wZV&w&c&y'WR&b%uR&_%pQ&|&gR'[&|Q&i%|R'P&iQ&d%wR&z&dQSOQ%sXQ%tYQ%|%fQ&m&SQ&n&TQ&o&UQ&p&VQ&q&WR'O&hQ&S%iQ&T%jQ&U%kQ&V%lR&W%m",
  nodeNames:
    "⚠ Bool Ignoring On GroupLeft GroupRight Offset Atan2 Avg Bottomk Count CountValues Group Max Min Quantile Stddev Stdvar Sum Topk By Without And Or Unless Start End Any BottomkAvg BottomkMax BottomkMedian BottomkLast BottomkMin Distinct Geomean Histogram Limitk Mad Median Mode OutliersMad Outliersk Quantiles Share Sum2 TopkAvg TopkMax TopkMedian TopkLast TopkMin Zscore LineComment PromQL AggregateExpr AggregateOp AggregateModifier GroupingLabels LabelName FunctionCallBody BinaryExpr Pow BoolModifier MatchingModifierClause Mul Div Mod Add Sub Eql Gte Gtr Lte Lss Neq FunctionCall FunctionIdentifier AbsentOverTime Identifier Absent Abs Acos Acosh Asin Asinh Atan Atanh AvgOverTime Ceil Changes Clamp ClampMax ClampMin Cos Cosh CountOverTime DaysInMonth DayOfMonth DayOfWeek DayOfYear Deg Delta Deriv Exp Floor HistogramCount HistogramFraction HistogramQuantile HistogramStdDev HistogramStdVar HistogramSum HoltWinters Hour Idelta Increase Irate LabelReplace LabelJoin LastOverTime Ln Log10 Log2 MaxOverTime MinOverTime Minute Month Pi PredictLinear PresentOverTime QuantileOverTime Rad Rate Resets Round Scalar Sgn Sin Sinh Sort SortDesc Sqrt StddevOverTime StdvarOverTime SumOverTime Tan Tanh Timestamp Time Vector Year AggrOverTime Alias AscentOverTime BitmapAnd BitmapOr BitmapXor BucketsLimit ChangesPrometheus CountEqOverTime CountGtOverTime CountLeOverTime CountNeOverTime DecreasesOverTime DefaultRollup DeltaPrometheus DerivFast DescentOverTime DistinctOverTime DropCommonLabels DurationOverTime FirstOverTime GeomeanOverTime HistogramAvg HistogramOverTime HistogramQuantiles HistogramShare HoeffdingBoundLower HoeffdingBoundUpper Ideriv IncreasePrometheus IncreasePure IncreasesOverTime Integrate Interpolate KeepLastValue KeepNextValue LabelCopy LabelDel LabelGraphiteGroup LabelKeep LabelLowercase LabelMap LabelMatch LabelMismatch LabelMove LabelSet LabelTransform LabelUppercase LabelValue Lag Lifetime LimitOffset MadOverTime MedianOverTime ModeOverTime Now PrometheusBuckets QuantilesOverTime Rand RandExponential RandNormal RangeAvg RangeFirst RangeLast RangeLinearRegression RangeMad RangeMax RangeMin RangeNormalize RangeOverTime RangeQuantile RangeStddev RangeStdvar RangeSum RangeTrimOutliers RangeTrimSpikes RangeTrimZscore RangeZscore RateOverSum RemoveResets Rollup RollupCandlestick RollupDelta RollupDeriv RollupIncrease RollupRate RollupScrapeInterval RunningAvg RunningMax RunningMin RunningSum ScrapeInterval ShareEqOverTime ShareGtOverTime ShareLeOverTime SmoothExponential SortByLabel SortByLabelDesc SortByLabelNumeric SortByLabelNumericDesc StaleSamplesOverTime Step Sum2OverTime TfirstOverTime TimestampWithName TimezoneOffset TlastChangeOverTime TlastOverTime TmaxOverTime TminOverTime Union ZscoreOverTime AvgDaily MedianDaily AvgWeekly MedianWeekly MedianWeeklyWithTrends MatrixSelector Duration NumberLiteral OffsetExpr ParenExpr StringLiteral SubqueryExpr UnaryExpr UnaryOp VectorSelector LabelMatchers LabelMatcher MatchOp EqlSingle EqlRegex NeqRegex StepInvariantExpr At AtModifierPreprocessors MetricName",
  maxTerm: 495,
  nodeProps: [
    [
      "group",
      -12,
      53,
      59,
      74,
      266,
      268,
      269,
      270,
      271,
      272,
      273,
      275,
      282,
      "Expr",
    ],
  ],
  propSources: [promQLHighLight],
  skippedNodes: [0, 51],
  repeatNodeCount: 3,
  tokenData:
    "3s~RwX^#lpq#lqr$ars$tst&luv'Twx'Yxy({yz)Qz{)V{|)[|})c}!O)h!O!P)o!P!Q*o!Q!R*t!R![+l![!]0W!^!_1S!_!`1a!`!a1v!b!c2T!c!}2Y!}#O2p#P#Q2u#Q#R2z#R#S2Y#S#T3P#T#o2Y#o#p3i#q#r3n#y#z#l$f$g#l#BY#BZ#l$IS$I_#l$I|$JO#l$JT$JU#l$KV$KW#l&FU&FV#l~#qY'a~X^#lpq#l#y#z#l$f$g#l#BY#BZ#l$IS$I_#l$I|$JO#l$JT$JU#l$KV$KW#l&FU&FV#l~$dQ!_!`$j#r#s$o~$oO!k~~$tO'T~~$yW&y~OY$tZr$trs%cs#O$t#O#P%h#P;'S$t;'S;=`&f<%lO$t~%hO&y~~%kRO;'S$t;'S;=`%t;=`O$t~%yX&y~OY$tZr$trs%cs#O$t#O#P%h#P;'S$t;'S;=`&f;=`<%l$t<%lO$t~&iP;=`<%l$t~&qS!T~OY&lZ;'S&l;'S;=`&}<%lO&l~'QP;=`<%l&l~'YO!c~~'_W&y~OY'YZw'Ywx%cx#O'Y#O#P'w#P;'S'Y;'S;=`(u<%lO'Y~'zRO;'S'Y;'S;=`(T;=`O'Y~(YX&y~OY'YZw'Ywx%cx#O'Y#O#P'w#P;'S'Y;'S;=`(u;=`<%l'Y<%lO'Y~(xP;=`<%l'Y~)QO'c~~)VO'e~~)[O!a~R)cO+oP!dQ~)hO'd~R)oO+nP!eQP)rP!Q![)uP)zR+pP!Q![)u!g!h*T#X#Y*TP*WR{|*a}!O*a!Q![*gP*dP!Q![*gP*lP+pP!Q![*g~*tO!b~R*yZ+pP!O!P)u!Q![+l!g!h*T#W#X,a#X#Y*T#[#],x#a#b-^#g#h.Q#k#l.c#l#m/l#m#n.}R+qY+pP!O!P)u!Q![+l!g!h*T#W#X,a#X#Y*T#[#],x#a#b-^#g#h.Q#k#l.c#m#n.}Q,fP&uQ!Q![,iQ,lS!Q![,i#[#],x#a#b-^#g#h.QQ,}P&uQ!Q![-QQ-TR!Q![-Q#a#b-^#g#h.QQ-cQ&uQ!Q![-i#g#h-{Q-lR!Q![-i#a#b-u#g#h.QQ-xP#g#h-{Q.QO&uQQ.VP&uQ!Q![.YQ.]Q!Q![.Y#a#b-uQ.hP&uQ!Q![.kQ.nT!Q![.k#W#X,a#[#],x#a#b-^#g#h.QQ/SP&uQ!Q![/VQ/YU!Q![/V#W#X,a#[#],x#a#b-^#g#h.Q#k#l.cP/oR!Q![/x!c!i/x#T#Z/xP/}R+pP!Q![/x!c!i/x#T#Z/xV0_T+qS!oR!Q![0n![!]0n!c!}0n#R#S0n#T#o0nR0sT!oR!Q![0n![!]0n!c!}0n#R#S0n#T#o0n~1XP!j~!_!`1[~1aO!i~~1fQ'RP!_!`1l#r#s1qQ1qO!fQ~1vO'S~~1{P!h~!_!`2O~2TO!g~~2YO'V~V2aT!oR!ZS!Q![2Y![!]0n!c!}2Y#R#S2Y#T#o2Y~2uO+l~~2zO+m~~3PO!^~~3STO#S3P#S#T%c#T;'S3P;'S;=`3c<%lO3P~3fP;=`<%l3P~3nO+r~~3sO+s~",
  tokenizers: [0, 1, 2],
  topRules: { PromQL: [0, 52], MetricName: [1, 285] },
  specialized: [
    {
      term: 77,
      get: (value, stack) => specializeIdentifier(value) << 1,
      external: specializeIdentifier,
    },
    {
      term: 77,
      get: (value, stack) => (extendIdentifier(value) << 1) | 1,
      external: extendIdentifier,
      extend: true,
    },
    { term: 77, get: (value) => spec_Identifier[value] || -1 },
  ],
  tokenPrec: 0,
})
// This file was generated by lezer-generator. You probably shouldn't edit it.
const inf = 290,
  nan = 291,
  Bool = 1,
  Ignoring = 2,
  On = 3,
  GroupLeft = 4,
  GroupRight = 5,
  Offset = 6,
  Atan2 = 7,
  Avg = 8,
  Bottomk = 9,
  Count = 10,
  CountValues = 11,
  Group = 12,
  Max = 13,
  Min = 14,
  Quantile = 15,
  Stddev = 16,
  Stdvar = 17,
  Sum = 18,
  Topk = 19,
  By = 20,
  Without = 21,
  And = 22,
  Or = 23,
  Unless = 24,
  Start = 25,
  End = 26,
  Any = 27,
  BottomkAvg = 28,
  BottomkMax = 29,
  BottomkMedian = 30,
  BottomkLast = 31,
  BottomkMin = 32,
  Distinct = 33,
  Geomean = 34,
  Histogram = 35,
  Limitk = 36,
  Mad = 37,
  Median = 38,
  Mode = 39,
  OutliersMad = 40,
  Outliersk = 41,
  Quantiles = 42,
  Share = 43,
  Sum2 = 44,
  TopkAvg = 45,
  TopkMax = 46,
  TopkMedian = 47,
  TopkLast = 48,
  TopkMin = 49,
  Zscore = 50,
  LineComment = 51,
  PromQL = 52,
  AggregateExpr = 53,
  AggregateOp = 54,
  AggregateModifier = 55,
  GroupingLabels = 56,
  LabelName = 57,
  FunctionCallBody = 58,
  BinaryExpr = 59,
  Pow = 60,
  BoolModifier = 61,
  MatchingModifierClause = 62,
  Mul = 63,
  Div = 64,
  Mod = 65,
  Add = 66,
  Sub = 67,
  Eql = 68,
  Gte = 69,
  Gtr = 70,
  Lte = 71,
  Lss = 72,
  Neq = 73,
  FunctionCall = 74,
  FunctionIdentifier = 75,
  AbsentOverTime = 76,
  Identifier = 77,
  Absent = 78,
  Abs = 79,
  Acos = 80,
  Acosh = 81,
  Asin = 82,
  Asinh = 83,
  Atan = 84,
  Atanh = 85,
  AvgOverTime = 86,
  Ceil = 87,
  Changes = 88,
  Clamp = 89,
  ClampMax = 90,
  ClampMin = 91,
  Cos = 92,
  Cosh = 93,
  CountOverTime = 94,
  DaysInMonth = 95,
  DayOfMonth = 96,
  DayOfWeek = 97,
  DayOfYear = 98,
  Deg = 99,
  Delta = 100,
  Deriv = 101,
  Exp = 102,
  Floor = 103,
  HistogramCount = 104,
  HistogramFraction = 105,
  HistogramQuantile = 106,
  HistogramStdDev = 107,
  HistogramStdVar = 108,
  HistogramSum = 109,
  HoltWinters = 110,
  Hour = 111,
  Idelta = 112,
  Increase = 113,
  Irate = 114,
  LabelReplace = 115,
  LabelJoin = 116,
  LastOverTime = 117,
  Ln = 118,
  Log10 = 119,
  Log2 = 120,
  MaxOverTime = 121,
  MinOverTime = 122,
  Minute = 123,
  Month = 124,
  Pi = 125,
  PredictLinear = 126,
  PresentOverTime = 127,
  QuantileOverTime = 128,
  Rad = 129,
  Rate = 130,
  Resets = 131,
  Round = 132,
  Scalar = 133,
  Sgn = 134,
  Sin = 135,
  Sinh = 136,
  Sort = 137,
  SortDesc = 138,
  Sqrt = 139,
  StddevOverTime = 140,
  StdvarOverTime = 141,
  SumOverTime = 142,
  Tan = 143,
  Tanh = 144,
  Timestamp = 145,
  Time = 146,
  Vector = 147,
  Year = 148,
  AggrOverTime = 149,
  Alias = 150,
  AscentOverTime = 151,
  BitmapAnd = 152,
  BitmapOr = 153,
  BitmapXor = 154,
  BucketsLimit = 155,
  ChangesPrometheus = 156,
  CountEqOverTime = 157,
  CountGtOverTime = 158,
  CountLeOverTime = 159,
  CountNeOverTime = 160,
  DecreasesOverTime = 161,
  DefaultRollup = 162,
  DeltaPrometheus = 163,
  DerivFast = 164,
  DescentOverTime = 165,
  DistinctOverTime = 166,
  DropCommonLabels = 167,
  DurationOverTime = 168,
  FirstOverTime = 169,
  GeomeanOverTime = 170,
  HistogramAvg = 171,
  HistogramOverTime = 172,
  HistogramQuantiles = 173,
  HistogramShare = 174,
  HoeffdingBoundLower = 175,
  HoeffdingBoundUpper = 176,
  Ideriv = 177,
  IncreasePrometheus = 178,
  IncreasePure = 179,
  IncreasesOverTime = 180,
  Integrate = 181,
  Interpolate = 182,
  KeepLastValue = 183,
  KeepNextValue = 184,
  LabelCopy = 185,
  LabelDel = 186,
  LabelGraphiteGroup = 187,
  LabelKeep = 188,
  LabelLowercase = 189,
  LabelMap = 190,
  LabelMatch = 191,
  LabelMismatch = 192,
  LabelMove = 193,
  LabelSet = 194,
  LabelTransform = 195,
  LabelUppercase = 196,
  LabelValue = 197,
  Lag = 198,
  Lifetime = 199,
  LimitOffset = 200,
  MadOverTime = 201,
  MedianOverTime = 202,
  ModeOverTime = 203,
  Now = 204,
  PrometheusBuckets = 205,
  QuantilesOverTime = 206,
  Rand = 207,
  RandExponential = 208,
  RandNormal = 209,
  RangeAvg = 210,
  RangeFirst = 211,
  RangeLast = 212,
  RangeLinearRegression = 213,
  RangeMad = 214,
  RangeMax = 215,
  RangeMin = 216,
  RangeNormalize = 217,
  RangeOverTime = 218,
  RangeQuantile = 219,
  RangeStddev = 220,
  RangeStdvar = 221,
  RangeSum = 222,
  RangeTrimOutliers = 223,
  RangeTrimSpikes = 224,
  RangeTrimZscore = 225,
  RangeZscore = 226,
  RateOverSum = 227,
  RemoveResets = 228,
  Rollup = 229,
  RollupCandlestick = 230,
  RollupDelta = 231,
  RollupDeriv = 232,
  RollupIncrease = 233,
  RollupRate = 234,
  RollupScrapeInterval = 235,
  RunningAvg = 236,
  RunningMax = 237,
  RunningMin = 238,
  RunningSum = 239,
  ScrapeInterval = 240,
  ShareEqOverTime = 241,
  ShareGtOverTime = 242,
  ShareLeOverTime = 243,
  SmoothExponential = 244,
  SortByLabel = 245,
  SortByLabelDesc = 246,
  SortByLabelNumeric = 247,
  SortByLabelNumericDesc = 248,
  StaleSamplesOverTime = 249,
  Step = 250,
  Sum2OverTime = 251,
  TfirstOverTime = 252,
  TimestampWithName = 253,
  TimezoneOffset = 254,
  TlastChangeOverTime = 255,
  TlastOverTime = 256,
  TmaxOverTime = 257,
  TminOverTime = 258,
  Union = 259,
  ZscoreOverTime = 260,
  AvgDaily = 261,
  MedianDaily = 262,
  AvgWeekly = 263,
  MedianWeekly = 264,
  MedianWeeklyWithTrends = 265,
  MatrixSelector = 266,
  Duration = 267,
  NumberLiteral = 268,
  OffsetExpr = 269,
  ParenExpr = 270,
  StringLiteral = 271,
  SubqueryExpr = 272,
  UnaryExpr = 273,
  UnaryOp = 274,
  VectorSelector = 275,
  LabelMatchers = 276,
  LabelMatcher = 277,
  MatchOp = 278,
  EqlSingle = 279,
  EqlRegex = 280,
  NeqRegex = 281,
  StepInvariantExpr = 282,
  At = 283,
  AtModifierPreprocessors = 284,
  MetricName = 285

export {
  Abs,
  Absent,
  AbsentOverTime,
  Acos,
  Acosh,
  Add,
  AggrOverTime,
  AggregateExpr,
  AggregateModifier,
  AggregateOp,
  Alias,
  And,
  Any,
  AscentOverTime,
  Asin,
  Asinh,
  At,
  AtModifierPreprocessors,
  Atan,
  Atan2,
  Atanh,
  Avg,
  AvgDaily,
  AvgOverTime,
  AvgWeekly,
  BinaryExpr,
  BitmapAnd,
  BitmapOr,
  BitmapXor,
  Bool,
  BoolModifier,
  Bottomk,
  BottomkAvg,
  BottomkLast,
  BottomkMax,
  BottomkMedian,
  BottomkMin,
  BucketsLimit,
  By,
  Ceil,
  Changes,
  ChangesPrometheus,
  Clamp,
  ClampMax,
  ClampMin,
  Cos,
  Cosh,
  Count,
  CountEqOverTime,
  CountGtOverTime,
  CountLeOverTime,
  CountNeOverTime,
  CountOverTime,
  CountValues,
  DayOfMonth,
  DayOfWeek,
  DayOfYear,
  DaysInMonth,
  DecreasesOverTime,
  DefaultRollup,
  Deg,
  Delta,
  DeltaPrometheus,
  Deriv,
  DerivFast,
  DescentOverTime,
  Distinct,
  DistinctOverTime,
  Div,
  DropCommonLabels,
  Duration,
  DurationOverTime,
  End,
  Eql,
  EqlRegex,
  EqlSingle,
  Exp,
  FirstOverTime,
  Floor,
  FunctionCall,
  FunctionCallBody,
  FunctionIdentifier,
  Geomean,
  GeomeanOverTime,
  Group,
  GroupLeft,
  GroupRight,
  GroupingLabels,
  Gte,
  Gtr,
  Histogram,
  HistogramAvg,
  HistogramCount,
  HistogramFraction,
  HistogramOverTime,
  HistogramQuantile,
  HistogramQuantiles,
  HistogramShare,
  HistogramStdDev,
  HistogramStdVar,
  HistogramSum,
  HoeffdingBoundLower,
  HoeffdingBoundUpper,
  HoltWinters,
  Hour,
  Idelta,
  Identifier,
  Ideriv,
  Ignoring,
  Increase,
  IncreasePrometheus,
  IncreasePure,
  IncreasesOverTime,
  Integrate,
  Interpolate,
  Irate,
  KeepLastValue,
  KeepNextValue,
  LabelCopy,
  LabelDel,
  LabelGraphiteGroup,
  LabelJoin,
  LabelKeep,
  LabelLowercase,
  LabelMap,
  LabelMatch,
  LabelMatcher,
  LabelMatchers,
  LabelMismatch,
  LabelMove,
  LabelName,
  LabelReplace,
  LabelSet,
  LabelTransform,
  LabelUppercase,
  LabelValue,
  Lag,
  LastOverTime,
  Lifetime,
  LimitOffset,
  Limitk,
  LineComment,
  Ln,
  Log10,
  Log2,
  Lss,
  Lte,
  Mad,
  MadOverTime,
  MatchOp,
  MatchingModifierClause,
  MatrixSelector,
  Max,
  MaxOverTime,
  Median,
  MedianDaily,
  MedianOverTime,
  MedianWeekly,
  MedianWeeklyWithTrends,
  MetricName,
  Min,
  MinOverTime,
  Minute,
  Mod,
  Mode,
  ModeOverTime,
  Month,
  Mul,
  Neq,
  NeqRegex,
  Now,
  NumberLiteral,
  Offset,
  OffsetExpr,
  On,
  Or,
  OutliersMad,
  Outliersk,
  ParenExpr,
  Pi,
  Pow,
  PredictLinear,
  PresentOverTime,
  PromQL,
  PrometheusBuckets,
  Quantile,
  QuantileOverTime,
  Quantiles,
  QuantilesOverTime,
  Rad,
  Rand,
  RandExponential,
  RandNormal,
  RangeAvg,
  RangeFirst,
  RangeLast,
  RangeLinearRegression,
  RangeMad,
  RangeMax,
  RangeMin,
  RangeNormalize,
  RangeOverTime,
  RangeQuantile,
  RangeStddev,
  RangeStdvar,
  RangeSum,
  RangeTrimOutliers,
  RangeTrimSpikes,
  RangeTrimZscore,
  RangeZscore,
  Rate,
  RateOverSum,
  RemoveResets,
  Resets,
  Rollup,
  RollupCandlestick,
  RollupDelta,
  RollupDeriv,
  RollupIncrease,
  RollupRate,
  RollupScrapeInterval,
  Round,
  RunningAvg,
  RunningMax,
  RunningMin,
  RunningSum,
  Scalar,
  ScrapeInterval,
  Sgn,
  Share,
  ShareEqOverTime,
  ShareGtOverTime,
  ShareLeOverTime,
  Sin,
  Sinh,
  SmoothExponential,
  Sort,
  SortByLabel,
  SortByLabelDesc,
  SortByLabelNumeric,
  SortByLabelNumericDesc,
  SortDesc,
  Sqrt,
  StaleSamplesOverTime,
  Start,
  Stddev,
  StddevOverTime,
  Stdvar,
  StdvarOverTime,
  Step,
  StepInvariantExpr,
  StringLiteral,
  Sub,
  SubqueryExpr,
  Sum,
  Sum2,
  Sum2OverTime,
  SumOverTime,
  Tan,
  Tanh,
  TfirstOverTime,
  Time,
  Timestamp,
  TimestampWithName,
  TimezoneOffset,
  TlastChangeOverTime,
  TlastOverTime,
  TmaxOverTime,
  TminOverTime,
  Topk,
  TopkAvg,
  TopkLast,
  TopkMax,
  TopkMedian,
  TopkMin,
  UnaryExpr,
  UnaryOp,
  Union,
  Unless,
  Vector,
  VectorSelector,
  Without,
  Year,
  Zscore,
  ZscoreOverTime,
  inf,
  nan,
  parser,
}
